unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls, StdCtrls, IdCookieManager, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, IdCookie,
  IdMultipartFormData, StrUtils, IdGlobalProtocols, uDragFilesTrg, ImgList,
  Inifiles, shlwapi, IdURI, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    ListView1: TListView;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ProgressBar1: TProgressBar;
    GroupBox4: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Edit4: TEdit;
    Memo1: TMemo;
    SpeedButton1: TSpeedButton;
    IdHTTP1: TIdHTTP;
    IdCookieManager1: TIdCookieManager;
    DragFilesTrg1: TDragFilesTrg;
    ImageList1: TImageList;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    procedure IdCookieManager1NewCookie(ASender: TObject;
      ACookie: TIdCookieRFC2109; var VAccept: Boolean);
    procedure Edit1Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    function  Process(): Boolean;
    procedure FormCreate(Sender: TObject);
    function  GetMediaWikiFilename(Filename: string): string;
    function  FilenameFixable(Filename: string): Boolean;
    procedure DragFilesTrg1Drop(Sender: TObject);
    procedure UpdateStatus(Item: TListItem);
    procedure UpdateGlobalStatus;
    procedure ListView1Edited(Sender: TObject; Item: TListItem; var S: string);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
    LoggedIn: Boolean;
    Succeeded: Integer;
    Failed: Integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

resourcestring
  AppName = 'MediaWiki-Uploadtool';
  LoginFailed = 'Fehler bei der Anmeldung!';
  Status0 = 'Bereit';                 // Cyan
  Status1 = 'In Bearbeitung';         // Gelb
  Status2 = 'Hochgeladen';            // Grn
  Status3 = 'Fehler beim Hochladen';  // Rot
  Status4 = 'Ungltiger Dateiname';   // Blau
  Status5 = 'Datei nicht gefunden';   // Pink

implementation

uses
  IdMUltipartFormDataFake;

{$R *.dfm}

procedure TForm1.DragFilesTrg1Drop(Sender: TObject);
var
  i: Integer;
  Item: TListItem;
begin
  ListView1.Items.BeginUpdate;
  try
    for i := 0 to DragFilesTrg1.FileCount - 1 do
    begin
      Item := ListView1.Items.Add;
      with Item do
      begin
        Caption := GetMediaWikiFilename(ExtractFileName(DragFilesTrg1.FileList.Strings[i]));
        SubItems.Add(DragFilesTrg1.FileList.Strings[i]);
        SubItems.Add('');
        if FileExists(DragFilesTrg1.FileList.Strings[i]) then
        if FilenameFixable(ExtractFileName(DragFilesTrg1.FileList.Strings[i])) then
        ImageIndex := 0
        else
        ImageIndex := 4
        else
        ImageIndex := 5;
      end;
      UpdateStatus(Item);
    end;
  finally
    ListView1.Items.EndUpdate;
    UpdateGlobalStatus;
  end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  LoggedIn := False;
end;

function TForm1.FilenameFixable(Filename: string): Boolean;
var
  i: Byte;
begin
  Result := not ((Pos('|', FileName) > 0) or
                 (Pos('<', FileName) > 0) or
                 (Pos('>', FileName) > 0) or
                 (Pos('#', FileName) > 0) or
                 (Pos('[', FileName) > 0) or
                 (Pos(']', FileName) > 0) or
                 (Pos('{', FileName) > 0) or
                 (Pos('}', FileName) > 0) or
                 (Pos('%', FileName) > 0) or
                 (Pos('?', FileName) > 0) or
                 (Pos('\', FileName) > 0) or
                 (Pos(#127, FileName) > 0) or
                 StartsStr('./', FileName) or
                 StartsStr('../', FileName) or
                 StartsStr(':', FileName));
  if Result then
  for i := 0 to 31 do
  if (Pos(Chr(i), FileName) > 0) then
  begin
    Result := False;
    Break;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  INI: TInifile;
begin
  try
    INI := TInifile.Create(ChangeFileExt(paramstr(0), '.ini'));
    INI.WriteString('Account','Wiki',Edit1.Text);
    INI.WriteString('Account','User',Edit2.Text);
    INI.WriteString('Account','Password',IfThen(CheckBox1.Checked,Edit3.Text));
    INI.WriteBool('Account','SavePW',CheckBox1.Checked);
    INI.WriteString('Settings','License',Edit4.Text);
  except
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  INI: TInifile;
begin
  DragFilesTrg1.Enabled := True;
  Succeeded := 0;
  Failed := 0;
  INI := TIniFile.Create(ChangeFileExt(paramstr(0), '.ini'));
  Edit1.Text := INI.ReadString('Account','Wiki','http://');
  Edit2.Text := INI.ReadString('Account','User','');
  Edit3.Text := INI.ReadString('Account','Password','');
  CheckBox1.Checked := INI.ReadBool('Account','SavePW',False);
  Edit4.Text := INI.ReadString('Settings','License','');
end;

function TForm1.GetMediaWikiFilename(Filename: string): string;
begin
  Result := StringReplace(Uppercase(FileName[1]) + MidStr(FileName, 2, 65535),
                          ' ','_',[rfReplaceAll]);
end;

procedure TForm1.IdCookieManager1NewCookie(ASender: TObject;
  ACookie: TIdCookieRFC2109; var VAccept: Boolean);
begin
  if ACookie.Value = StringReplace(Edit2.Text,' ','+',[rfReplaceAll]) then
  LoggedIn := True;
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
begin
  if ListView1.SelCount = 1 then
  if FilenameFixable(ListView1.Selected.Caption) then
  ListView1.Selected.ImageIndex := 0
  else
  ListView1.Selected.ImageIndex := 4
end;

procedure TForm1.ListView1Edited(Sender: TObject; Item: TListItem;
  var S: string);
begin
  if FilenameFixable(s) then
  Item.ImageIndex := 0
  else
  Item.ImageIndex := 4;
  s := GetMediaWikiFilename(s);
  UpdateStatus(Item);
end;

procedure TForm1.ListView1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  PreviousItem: TListItem;
  KillItem: TListItem;
  i: Integer;
begin
  if (ListView1.SelCount = 0) or ListView1.IsEditing then
  Exit;

  if Key = VK_DELETE then
  begin
    PreviousItem := ListView1.Selected;
    for i := 0 to ListView1.Items.Count - 1 do
    begin
      KillItem := PreviousItem;
      PreviousItem := ListView1.GetNextItem(PreviousItem, sdAll, [isSelected]);
      KillItem.Delete;
    end;
    UpdateGlobalStatus;
  end;

  if Key = VK_F2 then
  ListView1.Selected.EditCaption;
end;

function TForm1.Process(): Boolean;
var
  Item: TListItem;
  Data: TIdMultiPartFormDataStreamFake;
  i: Integer;
begin
  Item := nil;

  // Nchstes Objekt suchen
  for i := 0 to ListView1.Items.Count - 1 do
  if ListView1.Items.Item[i].ImageIndex = 0 then
  begin
    Item := ListView1.Items.Item[i];
    Break;
  end;
  if Item = nil then
  begin
    Result := False;
    Exit;
  end;
  Item.ImageIndex := 1;
  Item.Update;
  ListView1.Invalidate;
  Invalidate;

  // Daten hinzufgen
  Data := TIdMultiPartFormDataStreamFake.Create;
  Data.AddFile('wpUploadFile',
               Item.SubItems.Strings[0],
               GetMIMETypeFromFile(Item.SubItems.Strings[0]));
  Data.AddFormField('wpSourceType','file');
  Data.AddFormField('wpDestFile',Item.Caption);
  Data.AddFormField('wpUploadDescription',Memo1.Lines.Text);
  if Length(Edit4.Text) > 0 then
  Data.AddFormField('wpLicense',Edit4.Text);
  Data.AddFormField('wpIgnoreWarning','true');
  Data.AddFormField('wpUpload','Upload file');
  Data.AddFormField('wpDestFileWarningAck','1');
  // Hochladen
  try
  IdHTTP1.Post(Edit1.Text + '?title=Special:Upload', Data);
  except
  end;
  // Auswerten, ob 302 auf die Bilddatei zeigt
  if StrUtils.EndsText(':' + Item.Caption,UTF8Decode(TIdURI.URLDecode(IdHTTP1.Response.Location))) then
  begin
    //Application.MessageBox('Upload OK','blub',MB_OK);
    Item.ImageIndex := 2;
    inc(Failed);
  end
  else
  begin
    //Application.MessageBox('fail','epic',MB_OK);
    Item.ImageIndex := 3;
    inc(Failed);
  end;
  UpdateStatus(Item);
  Item.Update;
  //ListView1.Refresh;
  UpdateGlobalStatus;
  //Update;

  Data.Free;
  Result := True;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  Post: TStringList;
begin
  if SpeedButton1.Down then
  begin
    // Einloggen
    if not LoggedIn then
    begin
      Post := TStringList.Create;
      Post.Text := StringReplace('wpName=' + Edit2.Text + '&wpPassword=' + Edit3.Text + '&wpRemember=1&wpLoginattempt=UserLogin',' ','+',[rfReplaceAll]);
      try
        try
        IdHTTP1.Post(Edit1.Text + '?title=Special:UserLogin&returnto=Special:UserLogin', Post);
        except
        end;
      finally
        Post.Free;
      end;
    end;
    // Prfen, ob das Einloggen geklappt hat
    if LoggedIn then
    begin
      // Bei erfolgreichem Login wird die Liste abgearbeitet
      Edit1.Enabled := False;
      Edit2.Enabled := False;
      Edit3.Enabled := False;
      Timer1.Enabled := True;
    end
    else
    begin
      // Fehler ausgeben, wenn der Login fehlgeschlagen ist
      Application.MessageBox(PWideChar(LoginFailed), PWideChar(AppName), MB_OK);
      SpeedButton1.Down := False;
    end;
  end
  else
  if IdHTTP1.Connected then
  IdHTTP1.Disconnect;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if not Process then
  begin
    Timer1.Enabled := False;
    SpeedButton1.Down := False;
  end;
end;

procedure TForm1.UpdateGlobalStatus;
var
  i: Integer;
  j: Integer;
begin
  //if ListView1.Items.Count < ProgressBar1.Position then
  begin
    j := 0;
    for i := 0 to ListView1.Items.Count - 1 do
    if (ListView1.Items.Item[i].ImageIndex = 2) or
       (ListView1.Items.Item[i].ImageIndex = 3) then
       inc(j);
    ProgressBar1.Position := j;
  end;
  ProgressBar1.Max := ListView1.Items.Count;
  Label5.Caption := IntToStr(j) + '/' + IntToStr(ListView1.Items.Count);
  Label7.Caption := IntToStr(Succeeded) + '/' + IntToStr(Failed);
end;

procedure TForm1.UpdateStatus(Item: TListItem);
begin
  case Item.ImageIndex of
    0: Item.SubItems.Strings[1] := Status0;
    1: Item.SubItems.Strings[1] := Status1;
    2: Item.SubItems.Strings[1] := Status2;
    3: Item.SubItems.Strings[1] := Status3;
    4: Item.SubItems.Strings[1] := Status4;
    5: Item.SubItems.Strings[1] := Status5;
  end;
end;

end.
